C
C
C
      PROGRAM BDAFLOW
C
C     + + + PURPOSE + + +
C     This program builds the input file for DAFLOW
C
C     + + + PARAMETERS + + +
      INCLUDE 'params.inc'
C
C     + + + PARAMETER DEFINITIONS + + +
C     NOBR   - Maximum number of branches allowed in model
C     NOSC   - Maximum number of cross sections (grids) allowed in branch
C
C     + + + LOCAL VARIABLES + + +
      INTEGER I,IBC,IED,IENG,INX,IOUT(NOSC,NOBR),ITRM,J,JJ,JGO,JNCD,
     #        JNCU,JTS,K,N,NBC,NBB,NBRCH,NGB,NHR,NJNCT,NXSEC,
     #        LUBC,LUIN,LUOUT
      REAL   AA,AO(NOSC),A1(NOSC),A2(NOSC),DT,PF,Q(NOSC,NOBR),
     #       QO(NOSC,NOBR),SL(NOSC),QP,TA1,TA2,TAO,TD,TQ,TW1,TW2,
     #       W1(NOSC),W2(NOSC),X(NOSC)
      CHARACTER*64 VERSN
      CHARACTER*80 TITLE
C
C     + + + LOCAL DEFINITIONS + + +
C     IBC    - Code 1 to read file BC, 0 otherwise
C     IED    - Code 0 to create a new file 1 to read an 'OLD , FLOW.IN
C     IOUT   - (I,N) Code for output at grid I of branch N, where
C              1 output and 0 no output
C     ITRM   - Code 1 for input from terminal, 0 otherwise
C     NBC    - Number of boundary conditions
C     NBB    - Branch of new input for BC boundary condition
C     NGB    - Grid of new input for BC boundary condition
C     Q      - (I,N) Flow at grid I of branch N
C     QO     - (I,N) Old flow of grid I of branch N
C
C     + + + INPUT FORMATS + + +
 1010 FORMAT(20X,I10)
 1020 FORMAT(20X,F10.3)
 1030 FORMAT(13X,I3,16X,F5.2,16X,I3,8X,I3)
 1040 FORMAT('Grd R Mile  IOUT  Disch        A1        A2        AO',
     &'      Slope         W1    W2')
 1050 FORMAT(I3,G11.4,I2,G11.4,4G10.3,F7.1,F6.3)
 1060 FORMAT(12X,G12.4)
 1070 FORMAT(18X,I3)
 1080 FORMAT(10X,I3,5X,I3,3X,G14.5)
C
C     + + + INPUT/OUTPUT FORMATS + + +
 1000 FORMAT(A)
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT('  Enter title (no more than 80 characters)',/)
 2001 FORMAT(1X,A)
 2010 FORMAT('No. of Branches     ',I10,' *')
 2020 FORMAT('Internal Junctions  ',I10,' *')
 2030 FORMAT('Time Steps Modeled  ',I10,' *')
 2040 FORMAT('Model Starts        ',I10,' time steps after midnight.')
 2050 FORMAT('Output Given Every  ',I10,' Time Steps in "flow.out"')
 2060 FORMAT('0=Metric,1=English  ',I10,' *')
 2070 FORMAT('Time Step Size      ',F10.3,' Hours.')
 2080 FORMAT('Peak Discharge      ',F10.0,' *')
 2090 FORMAT('Branch',I3,' has',I3,' xsects & routes',F5.2,' of flow at'
     $,' JNCT',I3,' To JNCT',I3)
 2100 FORMAT('for Time',I5,' NBC=',I3,' *')
 2110 FORMAT(' Branch   ',I3,' Grid',I3,' Q=',G14.5,' *')
C
C     + + + END SPECIFICATIONS + + +
C
C     unix what information
      INCLUDE 'versn.inc'
      VERSN = '@(#)BDAFLOW - last modified May  5, 1994, kmf'
      VERSN = '@(#)BDAFLOW - last modified Sep 22, 1995, kmf'
C
C     notice to users
      WRITE(*,*)' This program reads from terminal to create a new file'
      WRITE(*,*)' It reads "old" to edit an existing file'
      WRITE(*,*)' Boundary conditions read from terminal and/or "bc"'
      WRITE(*,*)' Output written to "flow.in"'
      WRITE(*,*)' This program is dimensioned for:'
      WRITE(*,*)'     ', NOBR, ' branches'
      WRITE(*,*)'     ', NOSC, ' cross sections per branch.'
      WRITE(*,*)' Enter q to quit, 1 to continue '
      READ(*,'(I10)',ERR=999)JJ
C
C     set unit numbers and open required data files
      LUBC=17
      LUOUT=16
      OPEN (LUOUT,FILE='flow.in')
      LUIN=15
C
      WRITE(*,*)' Enter 0 to create new file, 1 to edit existing file- '
      READ(*,*)IED
C
      IF(IED.EQ.1) THEN
        OPEN(LUIN,FILE='old')
        READ(LUIN,1000)TITLE
      ELSE
        WRITE(*,2000)
        READ (*,1000)TITLE
      END IF
      WRITE(LUOUT,1000)TITLE
C
      IF(IED.EQ.1) THEN
        READ(LUIN,1010)NBRCH
      ELSE
        WRITE(*,*)' Enter number of branches = '
        READ(*,*)NBRCH
      END IF
      WRITE(LUOUT,2010)NBRCH
C
      IF(IED.EQ.1)THEN
        READ(LUIN,1010)NJNCT
      ELSE
        WRITE(*,*)' Enter number of internal junctions = '
        READ(*,*)NJNCT
      END IF
      WRITE(LUOUT,2020)NJNCT
C
      IF(IED.EQ.1)THEN
        READ(LUIN,1010)NHR
      ELSE
        WRITE(*,*)' Enter number of time steps to be modeled = '
        READ(*,*)NHR
      END IF
      WRITE(LUOUT,2030)NHR
C
      IF(IED.EQ.1)THEN
        READ(LUIN,1010)JTS
      ELSE
        JTS=0
        WRITE(*,*)' Enter number of time steps from midnight',
     $            ' to start of model. '
        WRITE(*,*)' To select default enter any letter except ',
     $            ' d or e, Default=0, JTS = '                          meb01/92
        READ(*,'(I10)',ERR=1)JJ                                         meb01/92
          JTS=JJ
    1   CONTINUE
      END IF
      WRITE(LUOUT,2040)JTS
C
      IF(IED.EQ.1)THEN
        READ(LUIN,1010)JGO
      ELSE
        JGO=1
        WRITE(*,*)' Enter number of time steps between outputs in',
     $            ' "flow.out" file, Default=1, JGO = '
        READ(*,'(I10)',ERR=2)JJ                                         meb01/92
          JGO=JJ
    2   CONTINUE
      END IF
      WRITE(LUOUT,2050)JGO
C
      IF(IED.EQ.1)THEN
        READ(LUIN,1010)IENG
      ELSE
        WRITE(*,*)' Enter 0 for metric units or',
     $            ' 1 for English units-  '
        READ(*,*)IENG
      END IF
      WRITE(LUOUT,2060)IENG
C
      IF(IED.EQ.1)THEN
        READ(LUIN,1020)DT
      ELSE
        WRITE(*,*)'Enter time step size in hours = '
        READ(*,*)DT
      END IF
      WRITE(LUOUT,2070)DT
C
      IF(IED.EQ.1)THEN
        READ(LUIN,1020)QP
      ELSE
        WRITE(*,*)'Enter maximum discharge of interest = '
        READ(*,*)QP
      END IF
      WRITE(LUOUT,2080)QP
      QP=QP/100000.0
      TQ=0.0
      TA1=7.0
      TA2=0.66
      TAO=0.0
      TD=0.0005
      TW1=50.0
      TW2=0.26
C
      DO 15 N=1,NBRCH
        IF(IED.EQ.1)THEN
          READ(LUIN,1030)NXSEC,PF,JNCU,JNCD
        ELSE
          WRITE(*,*)' For branch',N
          WRITE(*,*)'                    Number of cross sections = '
          READ(*,*)NXSEC
          WRITE(*,*)'   Junction number at upstream end of branch = '
          READ(*,*)JNCU
          WRITE(*,*)' Junction number at downstream end of branch = '
          READ(*,*)JNCD
          PF=1.0
          WRITE(*,*)' Part of flow at upstream junction to enter branch'
          WRITE(*,*)'                        Default=1.0 (100 %), PF = '
          READ(*,'(F10.0)',ERR=3)AA                                     meb01/92
            PF=AA
    3     CONTINUE
        END IF
        WRITE(LUOUT,2090)N,NXSEC,PF,JNCU,JNCD
        IF(IED.EQ.1) READ(LUIN,1000)TITLE
        WRITE(LUOUT,1040)
        IF(IED.EQ.0)WRITE(*,*)' For each cross section (grid) enter',
     $                        ' the following:'
        DO 11 I=1,NXSEC
          IF(IED.EQ.1)THEN
            IF (I.LT.NXSEC) THEN
              READ(LUIN,*)K,X(I),IOUT(I,1),Q(I,1),A1(I),A2(I),
     $                    AO(I),SL(I),W1(I),W2(I)
            ELSE IF (I.EQ.NXSEC) THEN
              READ(LUIN,*)K,X(I),IOUT(I,1)
            END IF
          ELSE
            WRITE(*,*)' Distance downstream from reference point(miles)'
            WRITE(*,*)'                          For grid',I,'  X(I) = '
            READ(*,*) X(I)
            IOUT(I,1)=0
            IF(I.NE.NXSEC) THEN
              WRITE(*,*)' Initial discharge at grid (Tribs enter just',
     $                  ' U/S of grid).  '
              WRITE(*,*)'Default =',TQ,' Q = '
              READ(*,'(F10.0)',ERR=4)Q(I,1)                             meb01/92
                TQ=Q(I,1)
    4         Q(I,1)=TQ
              WRITE(*,*)'Cross sectional area =AO + A1 Q^A2'
              WRITE(*,*)'Enter A1 for subreach, default=',TA1,' A1 = '
              READ(*,'(F10.0)',ERR=5)A1(I)                              meb01/92
                TA1=A1(I)
    5         A1(I)=TA1
              WRITE(*,*)' Enter A2 for subreach (0.0<A2<1.0),',
     $                  ' default=',TA2,'A2 = '
              READ(*,'(F10.0)',ERR=6)A2(I)                              meb01/92
                TA2=A2(I)
    6         A2(I)=TA2
              WRITE(*,*)' Enter cross sectional area at zero flow,',
     $                  ' default =',TAO,' AO = '
              READ(*,'(F10.0)',ERR=7)AO(I)                              meb01/92
                TAO=AO(I)
    7         AO(I)=TAO
              WRITE(*,*)' Enter slope of subreach, ',
     $                  ' default =',TD,' SL = '
              READ(*,'(F10.0)',ERR=8)SL(I)                              meb01/92
                TD=SL(I)
    8         SL(I)=TD
              WRITE(*,*)' Width = W1 Q^W2'
              WRITE(*,*)' Enter W1 for subreach downstream of grid,',
     $                  ' default =',TW1,' W1 = '
              READ(*,'(F10.0)',ERR=9)W1(I)                              meb01/92
                TW1=W1(I)
    9         W1(I)=TW1
              WRITE(*,*)' Enter W2 for subreach (0.0<W2<0.8),',
     $                  ' default =',TW2,' W2 = '
              READ(*,'(F10.0)',ERR=10)W2(I)                             meb01/92
                TW2=W2(I)
   10         W2(I)=TW2
            END IF
          END IF
   11   CONTINUE
        IF(IED.EQ.1)GO TO 13
          WRITE(*,*)' For branch',N
   12     WRITE(*,*)' Enter grid of desired output (enter Q if no',
     $              ' more output grids are desired) '
            READ(*,'(I10)',ERR=13)I                                     meb01/92
              IOUT(I,1)=1
          GO TO 12
   13   INX=NXSEC-1
        DO 14 I=1,INX
          WRITE(LUOUT,1050)I,X(I),IOUT(I,1),Q(I,1),A1(I),A2(I),AO(I),
     $                     SL(I),W1(I),W2(I)
   14   CONTINUE
        I=NXSEC
        WRITE(LUOUT,1050)I,X(I),IOUT(I,1)
   15 CONTINUE
C
C     Build boundary conditions
      DO 100 I=1,NOSC
        DO 100 N=1,NBRCH
          Q(I,N)=0.0
  100 CONTINUE
      IBC=0
      WRITE(*,*)' Enter 1 to read a boundary condition from file bc -'
      WRITE(*,*)' Enter 0 or n otherwise  '
      READ(*,'(I10)',ERR=110)JJ                                         meb01/92
        IBC=JJ
        IF(IBC.EQ.0)GO TO 110
          OPEN(LUBC,FILE='bc')
          WRITE(*,*)' Enter BRANCH of boundary condition in file "bc"-'
          READ(*,*)NBB
          WRITE(*,*)' Enter  GRID  of boundary condition in file "bc"-'
          READ(*,*)NGB
          READ(LUBC,1000)TITLE
          WRITE(*,2001)TITLE
          READ(LUBC,1000)TITLE
          WRITE(*,2001)TITLE
  110 ITRM=0
      WRITE(*,*)' Enter 1 to read boundary conditions from the terminal'
      WRITE(*,*)' Enter 0 or n otherwise  '
      READ(*,'(I10)',ERR=120)JJ                                         meb01/92
        ITRM=JJ
  120 DO 220 J=1,NHR
        DO 130 N=1,NBRCH
          DO 130 I=1,NOSC
            IF(IOUT(I,N).EQ.1)QO(I,N)=Q(I,N)
            IOUT(I,N)=0
  130   CONTINUE
C       Read boundary conditions from file "old"
        IF(IED.EQ.0)GO TO 150
          READ(LUIN,1070,END=150)NBC
            IF(NBC.EQ.0)GO TO 160
              DO 140 K=1,NBC
                READ(LUIN,1080,END=150)N,I,Q(I,N)
                IOUT(I,N)=1
  140         CONTINUE
              GO TO 160
  150   IED=0
  160   IF(IBC.NE.1)GO TO 170
C         Read boundary condition from file BC
          READ(LUBC,*)AA,Q(NGB,NBB)
          IOUT(NGB,NBB)=1
  170   IF(ITRM.NE.1)GO TO 190
C         Read boundary conditions from terminal
          WRITE(*,*)' For time step',J,' enter number of boundary',
     $              ' conditions to be entered from terminal-  '
          READ(*,*)NBC
          IF(NBC.EQ.0)GO TO 190
            DO 180 K=1,NBC
              WRITE(*,*)' Enter BRANCH of new boundary condition- '
              READ(*,*)N
              WRITE(*,*)'Enter  GRID  of new boundary condition- '
              READ(*,*)I
              Q(I,N)=QO(I,N)
              WRITE(*,*)' Enter new flow, Default=',Q(I,N),' Value= '
              READ(*,'(F10.0)',ERR=180)AA                               meb01/92
              Q(I,N)=AA
  180       IOUT(I,N)=1
  190   NBC=0
C       Find number of new boundary conditions
        NBC=0
        DO 200 N=1,NBRCH
          DO 200 I=1,NOSC
            IF(IOUT(I,N).EQ.0)GO TO 200
              AA=ABS(Q(I,N)-QO(I,N))
              IF(AA.LT.QP)IOUT(I,N)=0
              NBC=NBC+IOUT(I,N)
  200   CONTINUE
C       Write boundary conditions
        WRITE(LUOUT,2100)J,NBC
        IF(NBC.EQ.0)GO TO 220
          DO 210 N=1,NBRCH
            DO 210 I=1,NOSC
              IF(IOUT(I,N).EQ.1)WRITE(LUOUT,2110)N,I,Q(I,N)
  210     CONTINUE
  220 CONTINUE
C
C     close files
      ENDFILE(LUOUT)
      CLOSE(LUOUT)
      IF(IED.EQ.1)CLOSE(LUIN)
      IF(ITRM.EQ.1)CLOSE(LUBC)
C
  999 CONTINUE
C
      STOP
      END
