C
C
C
      PROGRAM   CEL
C
C     + + + PURPOSE + + +
C     This program computes Coefficients for area and width equations
C           A=AO+A1*(Q**A2)
C           W=W1*(Q**W2)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER IENG,IC,IO1,IW
      REAL A1,A2,AA,AH,AL,AN,ANH,ANL,AO,C,CH,CL,DL,DT,FN,Q,QH,QL,QM,
     #     RM,S,TA2,TW2,TH,TL,W1,W2,WL,WH,WW
      CHARACTER*64 VERSN
C
C     + + + END SPECIFICATIONS + + +
C
C     unix what information
      INCLUDE 'versn.inc'
      VERSN = '@(#)CEL - last modified May  5, 1994, kmf'
      VERSN = '@(#)CEL - last modified Feb  7, 1995, kmf'
      VERSN = '@(#)CEL - last modified Sep 21, 1995, kmf'
      VERSN = '@(#)CEL - last modified Apr 02, 1996, hej & kmf'
C
C     opt to compute wd from measured width or channel forming q - hej
      WRITE(*,*)' What do you want to do?'
      WRITE(*,*)' 1. Compute coefficients from Mannings n.'
      WRITE(*,*)' 2. Compute coefficients from lag times of hydrograph.'
      WRITE(*,*)' 3. Adjust wave speed holding A2 constant.'
      WRITE(*,*)' 4. Adjust A2 holding wave speed constant.'
      WRITE(*,*)' 5. Adjust W2 holding width constant.'
      WRITE(*,*)' Enter number of option=   '
      READ(*,*)IW
      IF(IW.EQ.1  .OR.  IW.EQ.2) GO TO 100
      IF(IW.EQ.3)GO TO 300
      IF(IW.EQ.4)GO TO 400
      IF(IW.EQ.5)GO TO 500
      GO TO 900
  100 CONTINUE
C       compute coefficients from Mannings's n or from lag times
        WRITE(*,*)' Enter bed slope=  '
        READ(*,*)S
        WRITE(*,*)' Enter 1 for English units, 0 for metric   '
        READ(*,*)IENG
        IF(IENG.EQ.0) THEN
C         metric units
          FN=1.0
        ELSE
C         assume english units
          FN=1.49
        END IF
C
C       Compute width coefficients
        WRITE(*,*)' Enter 1 to compute W1 from measured width,',
     $            ' 0 from channel forming discharge -  '
        READ(*,*)IO1
        IF(IO1.EQ.0)THEN
C         compute W1 from measured width
          W2=0.26
          WRITE(*,*)' To select default enter any letter.  '
          WRITE(*,*)' Enter W2, default=0.26, W2 = '
          READ(*,'(F9.0)',ERR=110)TW2
            W2=TW2
  110     CONTINUE
          WRITE(*,*)' Enter channel forming discharge -  '
          READ(*,*)QL
C         Computed by use of the equations given by Osterkamp
C         An equation fit to data in Barnes and Emmett (Salmon River) is
C          d(mm) = EXP(-2.60*(Q(channel forming)**0.91)*(S (slope)**0.40))
          IF(IENG.EQ.1) THEN
C           english units
            W1=3.343*(QL**(0.56-W2))
          ELSE
C           assume metric
            W1=7.5*(QL**(0.56-W2))
          END IF
        ELSE
C         compute W1 from channel forming discharge
          WRITE(*,*)' Enter discharge (not zero) where width',
     $              ' is known = '
          READ(*,*)QL
          WRITE(*,*)' Enter width at known discharge = '
          READ(*,*)WL
          WRITE(*,*)' Enter 0 to input W2 directly,',
     $              ' 1 to compute from another width-  '
          READ(*,*)IC
          IF(IC.EQ.0)THEN
            W2=0.26
            WRITE(*,*)' To select default enter any letter.  '
            WRITE(*,*)' Enter W2, default=0.26, Value = '
            READ(*,'(F9.0)',ERR=120)TW2
              W2=TW2
  120       CONTINUE
          ELSE
            WRITE(*,*)' Enter second discharge where width is known = '
            READ(*,*)QH
            WRITE(*,*)' Enter width at second discharge = '
            READ(*,*)WH
            W2=ALOG(WH/WL)/ALOG(QH/QL)
          END IF
          W1=WL/(QL**W2)
        END IF
C
C       Compute A1 and A2
        IF(IW.EQ.2)GO TO 140
C         compute coefficients from Manning's n
          WRITE(*,*)' Enter discharge where Mannings n is known = '
          READ(*,*)QL
          WRITE(*,*)' Enter Mannings n =  '
          READ(*,*)AN
          WRITE(*,*)' Enter cross-sectional area at zero flow = '
          READ(*,*)AO
          WL=W1*(QL**W2)
          AA=AN*QL*(WL**0.6667)/(FN*SQRT(S))
          AL=AA**0.6
          WRITE(*,*)' Enter 0 to input A2 from terminal,',
     $              ' 1 to compute from another Manings n- '
          READ(*,*)IC
          IF(IC.EQ.0)THEN
C           A2 entered from terminal
            A2=0.66
            WRITE(*,*)'     Enter A2 ,default=0.66, Value= '
            READ(*,'(F10.0)',ERR=130)TA2
              A2=TA2
  130       A1=(AL-AO)/(QL**A2)
          ELSE
C           compute from another Manning's n
            WRITE(*,*)' Enter second discharge where ',
     $                'Mannings n is known-'
            READ(*,*)QH
            WRITE(*,*)' Enter second Mannings n = '
            READ(*,*)AN
            WH=W1*(QH**W2)
            AA=AN*QH*(WH**0.6667)/(FN*SQRT(S))
            AH=AA**0.6
            A2=(ALOG(AH-AO)-ALOG(AL-AO))/(ALOG(QH)-ALOG(QL))
            A1=(AH-AO)/(QH**A2)
          END IF
          IF(IC.EQ.0)GO TO 170
            C=(QH**(1.0-A2))/(A1*A2)
            WRITE(*,*)' At a flow of',QH,' the wave celerity is',C
            GO TO 170
  140 CONTINUE
C       compute corfficients from lag time of hydrograph
        WRITE(*,*)' Enter discharge where wave speed is known =  '
        READ(*,*)QL
        WRITE(*,*)' Enter travel time of wave in hours = '
        READ(*,*)TL
        WRITE(*,*)' Enter reach length in miles = '
        READ(*,*)RM
        RM=RM*5280.0
        IF(IENG.EQ.0)RM=RM*0.3048
        CL=RM/(TL*3600.0)
        WRITE(*,*)' Celerity at first flow = ',CL
        WRITE(*,*)' Enter 0 to input A2 from terminal,',
     $            ' 1 to compute it from another wave speed  '
        READ(*,*)IC
        IF(IC.EQ.0)THEN
          A2=0.66
          WRITE(*,*)' Enter A2, default=0.66, Value = '
          READ(*,'(F10.0)',ERR=150)TA2
            A2=TA2
  150     CONTINUE
        ELSE
          WRITE(*,*)' Enter discharge at second peak = '
          READ(*,*)QH
          WRITE(*,*)' Enter travel time of wave in hours = '
          READ(*,*)TH
          CH=RM/(TH*3600.0)
          WRITE(*,*)' Celerity at second flow =  ',CH
          A2=1.0-(ALOG(CH/CL)/ALOG(QH/QL))
        END IF
        A1=(QL**(1.0-A2))/(A2*CL)
        WRITE(*,*)' Do you want to input AO or Mannings n?'
        WRITE(*,*)' The one you do not input will be computed.'
        WRITE(*,*)' Enter N to input Mannings n, 1 for AO  '
        READ(*,'(I10)',ERR=160)IW
C         compute approximate Mannings n
          WRITE(*,*)' Enter cross-sectional area at zero flow- '
          READ(*,*)AO
          AA=AO+A1*QL**A2
          ANL=FN*SQRT(S)*(AA**(5./3.))*(W1**(-2./3.))
          ANL=ANL*(QL**(-1.-2.*W2/3.))
          WRITE(*,*)' At a flow of',QL,' the approx. Mannings n is',ANL
          IF(IC.EQ.0)GO TO 170
            ANH=(AA**(5./3.))*(W1**(-2./3.))*(QH**(-1.-2.*W2/3.))
            ANH=ANH*FN*SQRT(S)
            WRITE(*,*)' At a flow of',QH,
     $                ' the approx. Mannings n is',ANH
            GO TO 170
  160   CONTINUE
C       compute AO
        WRITE(*,*)' Enter discharge where Mannings n is known =  '
        READ(*,*)Q
        WRITE(*,*)' Enter Mannings n = '
        READ(*,*)AN
        AA=((Q**(1.+2.0*W2/3.0))*(W1**(2.0/3.0))*AN/(FN*SQRT(S)))**0.6
        AO=AA-A1*(Q**A2)
  170   CONTINUE
        WRITE(*,*)' A=',AO,' + ',A1,' Q**',A2
        WRITE(*,*)' W= ',W1,' Q**',W2
        WRITE(*,*)' Slope = ',S
        C=(QL**(1.0-A2))/(A1*A2)
        WRITE(*,*)' At a flow of',QL,' the wave celerity is',C
        WRITE(*,*)' Enter time step size (hours) =  '
        READ(*,*)DT
        DL=(3600.0*DT*(QL**(1.0-W2))/(S*W1))**0.5
        WRITE(*,*)' And a representative wave length is =',DL
        DL=1.2*C*DT*3600.0
        WRITE(*,*)' For smooth results at this flow,',
     $            ' DL should be less than',DL
        WRITE(*,*)'   DL can be reduced by increasing DT, S, or width.'
        GO TO 900
C
  300 CONTINUE
C       adjust wave speed holding A2 constant
        WRITE(*,*)' Enter value of A2 = '
        READ(*,*)A2
        WRITE(*,*)' Enter discharge where wave speed is known = '
        READ(*,*)Q
        WRITE(*,*)' Enter known wave speed = '
        READ(*,*)C
        A1=(Q**(1.0-A2))/(C*A2)
        WRITE(*,*)' A=',A1,' Q**',A2
        GO TO 900
C
  400 CONTINUE
C       Adjust A2 holding wave speed constant
        WRITE(*,*)' Enter old A1 = '
        READ(*,*)A1
        WRITE(*,*)' Enter old A2 = '
        READ(*,*)A2
        WRITE(*,*)' Enter discharge where wave speed',
     $            ' is to be constant = '
        READ(*,*)QM
        C=(QM**(1.0-A2))/(A2*A1)
        WRITE(*,*)' Enter new A2 = '
        READ(*,*)A2
        A1=(QM**(1.0-A2))/(A2*C)
        WRITE(*,*)' A1=',A1
  410   WRITE(*,*)' Enter  Q where celerity is to be computed = '
          WRITE(*,*)' Enter Q to quit- '
          READ(*,'(F10.0)',ERR=900)Q
          C=(Q**(1.0-A2))/(A2*A1)
          WRITE(*,*)' Celerity = ',C
        GO TO 410
C
  500 CONTINUE
C       adjust W2 holding width constant
        WRITE(*,*)' Enter old W1 = '
        READ(*,*)W1
        WRITE(*,*)' Enter old W2 = '
        READ(*,*)W2
        WRITE(*,*)' Enter discharge where width is to be constant = '
        READ(*,*)QM
        WW=W1*(QM**W2)
        WRITE(*,*)' Enter new W2 = '
        READ(*,*)W2
        W1=WW/(QM**W2)
        WRITE(*,*)' W1=',W1
  510   CONTINUE
          WRITE(*,*)' Enter  Q where width is to be computed = '
          WRITE(*,*)' Enter Q to quit- '
          READ(*,'(F10.0)',ERR=900)Q
          WW=W1*Q**W2
          WRITE(*,*)' width = ',WW
        GO TO 510
C
  900 CONTINUE
C
      STOP
      END
