C
C
C
      SUBROUTINE   DRWLIM
     M                    ( XMIN, DX, XMAX, YMIN, DY, YMAX )
C
C     + + + PURPOSE + + +
C     dummy version of routine to let user modify the limits and tic
C     interval for the x and y axis.
C
C     + + + DUMMY ARGUMENTS + + +
      REAL   XMIN, DX, XMAX, YMIN, DY, YMAX
C
C     + + + ARGUMENT DEFINITIONS + + +
C     XMIN   - minimum value for x-axis
C     DX     - tic mark interval for x-axis
C     XMAX   - maximum value for x-axis
C     YMIN   - minimum value for y-axis
C     DY     - tic mark interval for y-axis
C     YMAX   - maximum value for y-axis
C
C     + + + END SPECIFICATIONS + + +
C
      RETURN
      END
C
C
C
      SUBROUTINE   DRWSET
     I                    ( XLAB, XMIN, DX, XMAX,
     I                      YLAB, YMIN, DY, YMAX,
     I                      MLAB, NG, NC )
C
C     + + + PURPOSE + + +
C     Dummy version of routine that asks user for graphics device.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER       NG, NC
      REAL          DX, DY, XMIN, XMAX, YMIN, YMAX
      CHARACTER*(*) XLAB, YLAB, MLAB
C
C     + + + ARGUMENT DEFINITIONS + + +
C     XLAB   - label for x-axis
C     XMIN   - minimum value for x-axis
C     DX     - tic mark interval for x-axis
C     XMAX   - maximum value for x-axis
C     YLAB   - label for y-axis
C     YMIN   - minimum value for y-axis
C     DY     - tic mark interval for y-axis
C     YMAX   - maximum value for y-axis
C     MLAB   - plot title
C     NG     - identification number
C     NC     - number of curves to be plotted
C
C     + + + END SPECIFICATIONS + + +
C
      RETURN
      END
C
C
C
      SUBROUTINE   DRWCRV
     I                    ( X, XMAX, XMIN, Y, YMAX, YMIN, NPTS,
     I                      LEGEND, LNTYPE, LNSYMB, LNCOLR )
C
C     + + + PURPOSE + + +
C     dummy plot routine, tells user graphics option not available.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER      NPTS, LNTYPE, LNSYMB, LNCOLR
      REAL         X(NPTS),XMAX,XMIN, Y(NPTS),YMAX,YMIN
      CHARACTER*20 LEGEND
C
C     + + + ARGUMENT DEFINITIONS + + +
C     X      - x coordinates of curve
C     XMAX   - maximum for x-axis
C     XMIN   - minimum for x-axis
C     Y      - y coordinates of curve
C     YMAX   - maximum for y-axis
C     YMIN   - minimum for y-axis
C     NPTS   - number of points to be drawn
C     LEGEND - curve legend
C     LNTYP  - line type
C     LNSYMB - symbol type
C     LNCOLR - line and symbol color
C
C     + + + END SPECIFICATIONS + + +
C
C     graphics not available
      WRITE (*,*)
      WRITE (*,*) ' Graphics option not available.'
      WRITE (*,*)
C
      RETURN
      END
C
C
C
      SUBROUTINE   DRWDON
C
C     + + + PURPOSE + + +
C     Dummy version of routine to shut down graphics.
C
C     + + + END SPECIFICATIONS + + +
C
      RETURN
      END
