#!/bin/sh
# clean.sh -- clean up unneeded files after test
#
# Usage: clean.sh
#
# History:  96/05/15  kmflynn

# remove files generated automatically
  if [ -f check.out ] ; then rm check.out ; fi

# remove files generated by 'unit' tests
  if [ -f test_W1.wdm ] ; then rm test_W1.wdm ; fi
  for No in 1 ; do
     for Sfx in cm lg ; do
        for Step in 1 2 3 4 5 ; do
           if [ -f test$No.$Sfx$Step ] ; then rm test$No.$Sfx$Step ; fi
        done
     done
  done

# remove files generated by problem tests

  for No in F1 F3 D1 W1 T1 Q2a Q2b Q2c ; do
    for Sfx in lg bc fl in pl ps ot bl ; do
      for Stp in 1 2 3 4 5 6 7 8 9 ; do
        if [ -f test_$No.$Sfx$Stp ] ; then rm test_$No.$Sfx$Stp ; fi
      done
    done
  done

# remove files that may be left if test exited unexpectedly
  for File in flow.in flow.out bltm.in bltm.out bltm.flw plt.out \
              out old in rt bc obs unit.in parcel.out temp.in    \
              qual2e.in old.bc ANNIE.LOG XPAD.DAT ERROR.FIL ; do
     if [ -f $File ] ; then rm $File ; fi
  done

# end of shell
